#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
//LSB Note: program complier model got to be 'compact'. Huge amount of memmory is used in this program.

/* User Guide for using .plw to .txt conversion program
For your 1000 files, I have yet another solution.
I had attach a c++ and .exe file.
I use turbo C++ 3.0 to compile.
.exe is to be use in microsoft DOS.
to do conversion,
key in the following command from dos
>PLWTOTXT 'filename' 'start range' 'end range'

for example you have a series of plw files to convert.
myfile0,myfile1,myfile2,myfile3,myfile4,myfile5 to myfile20
key in
>PLWTOTXT myfile 0 20 <press enter>
follow the instruction on the screen
and the converted files will be in .txt format save under the same directory.
*/


/*
The .plw file has a fixed-length header, followed by a data record for each sample. It is
terminated by a copy of the .pls file that was used to record it.
The first two-byte field of the header contains the length, in bytes, of the header. The
remaining fields are as follows:
*/

void plwToText(char *filename);

typedef struct PICO_header_struct
{
   unsigned short   header_bytes;
   char      signature[40];
   unsigned long   version;
   unsigned long   no_of_parameters;
   unsigned short   parameters[250];   // !! The value in the PICOlog documentation is entirely bogus!
   unsigned long   sample_no;
   unsigned long   no_of_samples;
   unsigned long   max_samples;
   unsigned long   interval;
   unsigned short   interval_units;
   unsigned long   trigger_sample;
   unsigned short   triggered;
   unsigned long   first_sample;
   unsigned long   sample_bytes;
   unsigned long   settings_bytes;
   unsigned long   start_date;
   unsigned long   start_time;
   long      minimum_time;
   long      maximum_time;
   char      notes[200];
   long      current_time;
   unsigned char   spare[78];
};

class PICO_data_reading
{
public:
	unsigned long time_count;
	float voltage;
};

void main(int argc,char **argv)
{
	clrscr();

	if(argc==1)
	{
		printf("file name not specified (program 'filename' 'start range' 'end range')\n");
	}
	else if(argc==2)
	{
		printf("Converting %s\n",argv[1]);
		getch();
		plwToText(argv[1]);
	}
	else if(argc==3)
	{
		printf("End range required\n");
	}
	else if(argc==4)
	{
		int start=atoi(argv[2]);
		int end=atoi(argv[3]);
		printf("Converting files \"%s\" from %d to %d\n",argv[1],start,end);
		getch();
		for(int x=start;x<=end;x++)
		{
			char string[50];
			sprintf(string,"%s%d",argv[1],x);
			plwToText(string);
		}
	}
	else
	{
		printf("too many parameter\n");
	}
	printf("Program terminated\n");
}

void plwToText(char *filename)
{
	PICO_header_struct file_header;
//	PICO_data_reading **data_buffer;
//	PICO_data_reading *data_set;

	FILE *fptr;
	FILE *fptrOut;
	char out_file[50];
	sprintf(out_file,"%s.txt",filename);
	strcat(filename,".plw");

	printf("Convert file \"%s\" to \"*.txt\" \n",filename);

	if((fptr=fopen(filename,"rb"))==NULL)
	{
		printf("Error: file open fail\n");
		getch();
		return;
	}
	if((fptrOut=fopen(out_file,"w+t"))==NULL)
	{
		printf("Error: file open fail\n");
		getch();
		return;
	}
	if(!fread(&file_header, sizeof(file_header), 1,fptr))
	{
		printf("Error: file header read fail\n");
		getch();
		return;
	}
//	data_buffer=(PICO_data_reading**)malloc(file_header.sample_no*sizeof(PICO_data_reading*));
	fseek(fptr,800,SEEK_CUR);
	unsigned long y=0;
//	for(unsigned long x=0;x<file_header.sample_no;x++)
	for(unsigned long x=0;x<100000;x++)
	{
		PICO_data_reading temp;
//		temp=(PICO_data_reading*)malloc(sizeof(PICO_data_reading));
//		*(data_buffer+x)=temp;

		if(!fread(&temp,sizeof(PICO_data_reading), 1,fptr))
		{
			printf("Error: file data read fail\n");
			getch();
			return;
		}

//		printf("%ld, %ld, %ld, %f\n",file_header.sample_no,x,temp.time_count,temp.voltage);
		char string[50];
		sprintf(string,"%ld\t\t%f\n",temp.time_count,temp.voltage);
//		printf("%s\n",string);
		fwrite(string,strlen(string),1,fptrOut);

//		if(x>=31234)
//		{
//			printf("%ld, %ld, %ld, %f\n",file_header.sample_no,x,(*(tempdata_set)).time_count,(*(tempdata_set)).voltage);
//			getch();
//		}
	}

	x=99900;
	x=0;
//	printf("%ld, %ld, %ld, %f\n",file_header.sample_no,x,(*(*(data_buffer+x))).time_count,(*(*(data_buffer+x))).voltage);

/*
	printf("%s, %ld\n",file_header.signature,file_header.version);
	printf("no of parameters\t%ld\n",file_header.no_of_parameters);
	printf("sample_no       \t%ld\n",file_header.sample_no);
	printf("no_of_samples   \t%ld\n",file_header.no_of_samples);
	printf("max_samples     \t%ld\n",file_header.max_samples);
	printf("interval        \t%ld\n",file_header.interval);
	printf("interval_units  \t%d\n",file_header.interval_units);
	printf("trigger_sample  \t%ld\n",file_header.trigger_sample);
	printf("triggered       \t%d\n",file_header.triggered);
	printf("first_sample    \t%ld\n",file_header.first_sample);
	printf("sample_bytes    \t%ld\n",file_header.sample_bytes);
	printf("settings_bytes  \t%ld\n",file_header.settings_bytes);
	printf("start_date      \t%ld\n",file_header.start_date);
	printf("start_time      \t%ld\n",file_header.start_time);
	printf("minimum_time    \t%ld\n",file_header.minimum_time);
	printf("maximum_time    \t%ld\n",file_header.maximum_time);
	printf("notes           \t%s\n",file_header.notes);
	printf("maximum_time    \t%ld\n",file_header.maximum_time);
	printf("spare           \t%s\n",file_header.spare);

*/
//	getch();
	fclose(fptr);
	fclose(fptrOut);
	//release memory allocated
	for(x=0;x<file_header.sample_no;x++)
	{
//		free(*(data_buffer+x));
	}
//	free(data_buffer);
}
